<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onMounted, onBeforeUnmount, ref } from 'vue';
import { useI18n } from 'vue-i18n';
import { checkFileExtension, checkType } from '@/lib/utils';

const props = defineProps<{
    modelValue: string,
    accept: string,
    fileSize?: number,
    error:string
}>();

const emits = defineEmits<{
    (e: 'update:modelValue', value: any): void,
    (e: 'error', value: boolean): void
}>();

const showTextError = ref(false);
const fileName = ref('');

const { t } = useI18n();
const $t = t; 

const fileUpload = (event:any)=>{
    showTextError.value = false;
    const files = event.dataTransfer? event.dataTransfer.files:event.target.files;
    if (files[0] !== null && 
    (checkFileExtension(props.accept, files[0].name) || checkType(props.accept, files[0].type)) && 
    (props.fileSize?files[0].size<=props.fileSize:true)) {
        const fileReader = new FileReader();
        fileReader.readAsDataURL(files[0]);
        let file = files[0];
        fileName.value = file.name;
        emits('update:modelValue', file);
        if(event.target)
            event.target.value = "";
    }else{
        showTextError.value = true;
        emits('error',true);
    }
};

const preventDefaults = (e:any)=> {
    e.preventDefault()
};

const events = ['dragenter', 'dragover', 'dragleave', 'drop'];
onMounted(() => {
    events.forEach((eventName) => {
        document.body.addEventListener(eventName, preventDefaults)
    })
});

onBeforeUnmount(() => {
    events.forEach((eventName) => {
        document.body.removeEventListener(eventName, preventDefaults)
    })
});


</script>
<template>
<label>
    <div class="text-center border border-dashed border-gray-300 h-20 max-h-20 flex flex-col justify-center gap-1 cursor-pointer p-4 rounded-md" @drop.prevent="fileUpload">
        <div class="flex flex-row gap-2 w-full justify-center align-middle">
            <i class="ri-upload-cloud-2-line"></i>
            <span class="">{{$t('contentPage.post.upload.droparea')}}</span>
        </div>
        <div class="w-full text-center" v-if="!showTextError">
            <span class="line-clamp-1">{{fileName}}</span>
        </div>
        <div class="w-full" v-if="showTextError">
            <span class="text-orange-400">{{error}}</span>
        </div>
        
    </div>
    <!--<input type="file" @change="fileUpload" :accept="accept" hidden>-->
    <input type="file" @change="fileUpload" hidden>
</label>
</template>